8.【LeetCode 18】四数之和 —— Java 排序 + 双指针解法详解

目录

[1. 题目解析](#1. 题目解析)

[18. 四数之和​](#18. 四数之和)

[示例 1:](#示例 1:)

[示例 2:](#示例 2:)

[2. 算法原理](#2. 算法原理)

[解法一:排序 + 暴力枚举 + 利用 set 去重](#解法一:排序 + 暴力枚举 + 利用 set 去重)

[解法二:排序 + 双指针](#解法二:排序 + 双指针)

处理细节问题:

[3. 编写代码](#3. 编写代码)


OJ链接:https://leetcode.cn/problems/4sum/description/


1. 题目解析

18. 四数之和​

难度:中等

给你一个由 n 个整数组成的数组 nums,和一个目标值 target。请你找出并返回满足下述全部条件且不重复的四元组 [nums[a], nums[b], nums[c], nums[d]](若两个四元组元素一一对应,则认为两个四元组重复):

  • 0 <= a, b, c, d < n

  • a、b、c和 d互不相同

  • nums[a] + nums[b] + nums[c] + nums[d] == target

你可以按任意顺序返回答案。


示例 1:

输入:nums = [1,0,-1,0,-2,2], target = 0

输出:[[-2,-1,1,2],[-2,0,0,2],[-1,0,0,1]]


示例 2:

输入:nums = [2,2,2,2,2], target = 8

输出:[[2,2,2,2]]


2. 算法原理

解法一:排序 + 暴力枚举 + 利用 set 去重


解法二:排序 + 双指针

  • 依次固定一个数 a;
  • 在 a后面的区间内,利用"三数之和"找到三个数,使这三个数的和等于 target - a即可。

进一步细化:

复制代码
1. 依次固定一个数 b;
2. 在 b 后面的区间内,利用"双指针"找到两个数,
   使这两个数的和等于 target - a - b 即可。

处理细节问题:

  1. 不重

  2. 不漏


3. 编写代码

java 复制代码
class Solution {
    public List<List<Integer>> fourSum(int[] nums, int target) {
        List<List<Integer>> ret = new ArrayList<>();

        //排序
        Arrays.sort(nums);

        //四数之和
        int n = nums.length;
        for(int i = 0; i < n - 3; ){//固定i
            //三数之和
            for(int j = i + 1; j < n - 2; ){//固定j
                //两數之和
                int left = j + 1, right = n - 1;
                //避免溢出,这里需要使用Long!!!
                long aim = (long)target - nums[i] - nums[j];
                while(left < right){
                    int sum = nums[left] + nums[right];
                    if(sum > aim) right--;
                    else if(sum < aim) left++;
                    else{
                        ret.add(Arrays.asList(nums[i],nums[j],nums[left],nums[right]));
                        //不漏
                        left++; right--;
                        //去重一
                        while(left < right && nums[left] == nums[left - 1]) left++;
                        while(left < right && nums[right] == nums[right + 1]) right--;
                    }
                }
                //去重二
                j++;
                while(j < n && nums[j] == nums[j - 1]) j++;
            }
            //去重三
            i++;
            while(i < n && nums[i] == nums[i - 1]) i++;
        }
        return ret;
    }
}
相关推荐
Interview Aid11229 分钟前
Google SWE Intern Interview Process:OA、Coding 与面试流程详解
面试·职场和发展
hetao17338371 小时前
2026-09-29 hetao1733837 的刷题记录
c++·算法
欣欣之王来了2 小时前
AI合规专项:AI算法透明度的合规要求
人工智能·算法
wzdark2 小时前
分块思想在算法优化中的实践与应用4
算法
Because_of_Her12 小时前
dfs-洪水填充技巧
笔记·算法·深度优先·洪水填充
小静AI工程实验室2 小时前
RSA 算法详解:从模幂原理到 OAEP 加密、PSS 签名与 Python 实验
python·算法
xzal122 小时前
GESP Python笔记
笔记·python·算法
wzdark2 小时前
算法中的记忆化思想与重复子问题优化4
算法
Discipline10293 小时前
流水线运行是否正随时间变得更加集中?
算法
lzhdim3 小时前
C#不为人知的10个魔法特性:资深开发者也会震惊的底层奥秘
java·前端·javascript·算法·c#